<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:24 CEST 2019 -->
<title>AbstractFbDatabase (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="AbstractFbDatabase (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":6,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbBlob.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbService.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/AbstractFbDatabase.html" target="_top">Frames</a></li>
<li><a href="AbstractFbDatabase.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields.inherited.from.class.org.firebirdsql.gds.ng.AbstractFbAttachment">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng</div>
<h2 title="Class AbstractFbDatabase" class="title">Class AbstractFbDatabase&lt;T extends <a href="../../../../org/firebirdsql/gds/ng/AbstractConnection.html" title="class in org.firebirdsql.gds.ng">AbstractConnection</a>&lt;<a href="../../../../org/firebirdsql/gds/ng/IConnectionProperties.html" title="interface in org.firebirdsql.gds.ng">IConnectionProperties</a>,? extends <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>&gt;&gt;</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html" title="class in org.firebirdsql.gds.ng">org.firebirdsql.gds.ng.AbstractFbAttachment</a>&lt;T&gt;</li>
<li>
<ul class="inheritance">
<li>org.firebirdsql.gds.ng.AbstractFbDatabase&lt;T&gt;</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a>, <a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html" title="interface in org.firebirdsql.gds.ng">FbAttachment</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">TransactionListener</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/wire/AbstractFbWireDatabase.html" title="class in org.firebirdsql.gds.ng.wire">AbstractFbWireDatabase</a>, <a href="../../../../org/firebirdsql/gds/ng/jna/JnaDatabase.html" title="class in org.firebirdsql.gds.ng.jna">JnaDatabase</a></dd>
</dl>
<hr>
<br>
<pre>public abstract class <span class="typeNameLabel">AbstractFbDatabase&lt;T extends <a href="../../../../org/firebirdsql/gds/ng/AbstractConnection.html" title="class in org.firebirdsql.gds.ng">AbstractConnection</a>&lt;<a href="../../../../org/firebirdsql/gds/ng/IConnectionProperties.html" title="interface in org.firebirdsql.gds.ng">IConnectionProperties</a>,? extends <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>&gt;&gt;</span>
extends <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html" title="class in org.firebirdsql.gds.ng">AbstractFbAttachment</a>&lt;T&gt;
implements <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">TransactionListener</a></pre>
<div class="block">Abstract implementation of <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng"><code>FbDatabase</code></a> with behavior common to the various
 implementations.</div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="fields.inherited.from.class.org.firebirdsql.gds.ng.AbstractFbAttachment">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;org.firebirdsql.gds.ng.<a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html" title="class in org.firebirdsql.gds.ng">AbstractFbAttachment</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#connection">connection</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#exceptionListenerDispatcher">exceptionListenerDispatcher</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier</th>
<th class="colLast" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected </code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#AbstractFbDatabase-T-org.firebirdsql.gds.ng.DatatypeCoder-">AbstractFbDatabase</a></span>(<a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html" title="type parameter in AbstractFbDatabase">T</a>&nbsp;connection,
                  <a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.html" title="interface in org.firebirdsql.gds.ng">DatatypeCoder</a>&nbsp;datatypeCoder)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#addDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">addDatabaseListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners">DatabaseListener</a>&nbsp;listener)</code>
<div class="block">Adds a <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>DatabaseListener</code></a> instance to this database.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#addWeakDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">addWeakDatabaseListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners">DatabaseListener</a>&nbsp;listener)</code>
<div class="block">Adds a <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>DatabaseListener</code></a> instance to this database using a weak reference.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#close--">close</a></span>()</code>
<div class="block">Detaches and closes the connection.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/BlobParameterBuffer.html" title="interface in org.firebirdsql.gds">BlobParameterBuffer</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#createBlobParameterBuffer--">createBlobParameterBuffer</a></span>()</code>
<div class="block">Creates a blob parameter buffer that is usable with <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobForInput-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.BlobParameterBuffer-long-"><code>FbDatabase.createBlobForInput(FbTransaction,
 org.firebirdsql.gds.BlobParameterBuffer, long)</code></a>
 and <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobForOutput-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.BlobParameterBuffer-"><code>FbDatabase.createBlobForOutput(FbTransaction, org.firebirdsql.gds.BlobParameterBuffer)</code></a> of this instance.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/impl/TransactionParameterBufferImpl.html" title="class in org.firebirdsql.gds.impl">TransactionParameterBufferImpl</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#createTransactionParameterBuffer--">createTransactionParameterBuffer</a></span>()</code>
<div class="block">Creates a transaction parameter buffer that is usable with <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#startTransaction-org.firebirdsql.gds.TransactionParameterBuffer-"><code>FbDatabase.startTransaction(org.firebirdsql.gds.TransactionParameterBuffer)</code></a>.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#emptyRowDescriptor--">emptyRowDescriptor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getActiveTransactionCount--">getActiveTransactionCount</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>short</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getConnectionDialect--">getConnectionDialect</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/IConnectionProperties.html" title="interface in org.firebirdsql.gds.ng">IConnectionProperties</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getConnectionProperties--">getConnectionProperties</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>short</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getDatabaseDialect--">getDatabaseDialect</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>&lt;R&gt;&nbsp;R</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getDatabaseInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">getDatabaseInfo</a></span>(byte[]&nbsp;requestItems,
               int&nbsp;bufferLength,
               <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;R&gt;&nbsp;infoProcessor)</code>
<div class="block">Request database info.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;<a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getDatabaseInformationProcessor--">getDatabaseInformationProcessor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/WarningMessageCallback.html" title="interface in org.firebirdsql.gds.ng">WarningMessageCallback</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getDatabaseWarningCallback--">getDatabaseWarningCallback</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>protected byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getDescribeDatabaseInfoBlock--">getDescribeDatabaseInfoBlock</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getOdsMajor--">getOdsMajor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getOdsMinor--">getOdsMinor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getParameterDescriptionInfoRequestItems--">getParameterDescriptionInfoRequestItems</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getStatementInfoRequestItems--">getStatementInfoRequestItems</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>protected abstract void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#internalDetach--">internalDetach</a></span>()</code>
<div class="block">Actual implementation of database detach.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#removeDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">removeDatabaseListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners">DatabaseListener</a>&nbsp;listener)</code>
<div class="block">Removes a <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>DatabaseListener</code></a> instance from this database.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#setDatabaseDialect-short-">setDatabaseDialect</a></span>(short&nbsp;dialect)</code>
<div class="block">Sets the dialect of the database.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#setOdsMajor-int-">setOdsMajor</a></span>(int&nbsp;odsMajor)</code>
<div class="block">Sets the ODS (On Disk Structure) major version of the database associated
 with this connection.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#setOdsMinor-int-">setOdsMinor</a></span>(int&nbsp;odsMinor)</code>
<div class="block">Sets the ODS (On Disk Structure) minor version of the database associated
 with this connection.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#transactionAdded-org.firebirdsql.gds.ng.FbTransaction-">transactionAdded</a></span>(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;transaction)</code>
<div class="block">Called when a transaction is added by the database.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#transactionStateChanged-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.ng.TransactionState-org.firebirdsql.gds.ng.TransactionState-">transactionStateChanged</a></span>(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;transaction,
                       <a href="../../../../org/firebirdsql/gds/ng/TransactionState.html" title="enum in org.firebirdsql.gds.ng">TransactionState</a>&nbsp;newState,
                       <a href="../../../../org/firebirdsql/gds/ng/TransactionState.html" title="enum in org.firebirdsql.gds.ng">TransactionState</a>&nbsp;previousState)</code>
<div class="block">Signals that the transaction state changed.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.firebirdsql.gds.ng.AbstractFbAttachment">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.firebirdsql.gds.ng.<a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html" title="class in org.firebirdsql.gds.ng">AbstractFbAttachment</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">addExceptionListener</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#checkConnected--">checkConnected</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#createDbCryptCallback--">createDbCryptCallback</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#getDatatypeCoder--">getDatatypeCoder</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#getEncoding--">getEncoding</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#getEncodingFactory--">getEncodingFactory</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#getServerVersion--">getServerVersion</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#getServerVersionInformation--">getServerVersionInformation</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#getSynchronizationObject--">getSynchronizationObject</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#isAttached--">isAttached</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">removeExceptionListener</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#safelyDetach--">safelyDetach</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#setAttached--">setAttached</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#setDetached--">setDetached</a>, <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#setServerVersion-java.lang.String...-">setServerVersion</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.firebirdsql.gds.ng.FbDatabase">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.firebirdsql.gds.ng.<a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#cancelEvent-org.firebirdsql.gds.EventHandle-">cancelEvent</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#cancelOperation-int-">cancelOperation</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#countEvents-org.firebirdsql.gds.EventHandle-">countEvents</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobForInput-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.BlobParameterBuffer-long-">createBlobForInput</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobForOutput-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.BlobParameterBuffer-">createBlobForOutput</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createDatabase--">createDatabase</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createEventHandle-java.lang.String-org.firebirdsql.gds.EventHandler-">createEventHandle</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createStatement-org.firebirdsql.gds.ng.FbTransaction-">createStatement</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#dropDatabase--">dropDatabase</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#executeImmediate-java.lang.String-org.firebirdsql.gds.ng.FbTransaction-">executeImmediate</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getDatabaseInfo-byte:A-int-">getDatabaseInfo</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getHandle--">getHandle</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#queueEvent-org.firebirdsql.gds.EventHandle-">queueEvent</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#reconnectTransaction-long-">reconnectTransaction</a>, <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#startTransaction-org.firebirdsql.gds.TransactionParameterBuffer-">startTransaction</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.firebirdsql.gds.ng.FbAttachment">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.firebirdsql.gds.ng.<a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html" title="interface in org.firebirdsql.gds.ng">FbAttachment</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#attach--">attach</a>, <a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#getDatatypeCoder--">getDatatypeCoder</a>, <a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#getEncoding--">getEncoding</a>, <a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#getEncodingFactory--">getEncodingFactory</a>, <a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#getServerVersion--">getServerVersion</a>, <a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#getSynchronizationObject--">getSynchronizationObject</a>, <a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#isAttached--">isAttached</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.firebirdsql.gds.ng.listeners.ExceptionListenable">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.firebirdsql.gds.ng.listeners.<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">addExceptionListener</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">removeExceptionListener</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="AbstractFbDatabase-org.firebirdsql.gds.ng.AbstractConnection-org.firebirdsql.gds.ng.DatatypeCoder-">
<!--   -->
</a><a name="AbstractFbDatabase-T-org.firebirdsql.gds.ng.DatatypeCoder-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>AbstractFbDatabase</h4>
<pre>protected&nbsp;AbstractFbDatabase(<a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html" title="type parameter in AbstractFbDatabase">T</a>&nbsp;connection,
                             <a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.html" title="interface in org.firebirdsql.gds.ng">DatatypeCoder</a>&nbsp;datatypeCoder)</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getDatabaseWarningCallback--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDatabaseWarningCallback</h4>
<pre>public final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/WarningMessageCallback.html" title="interface in org.firebirdsql.gds.ng">WarningMessageCallback</a>&nbsp;getDatabaseWarningCallback()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The warning callback for this database.</dd>
</dl>
</li>
</ul>
<a name="getActiveTransactionCount--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getActiveTransactionCount</h4>
<pre>public final&nbsp;int&nbsp;getActiveTransactionCount()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Number of active (not prepared or committed/rolled back) transactions</dd>
</dl>
</li>
</ul>
<a name="transactionAdded-org.firebirdsql.gds.ng.FbTransaction-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>transactionAdded</h4>
<pre>protected final&nbsp;void&nbsp;transactionAdded(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;transaction)</pre>
<div class="block">Called when a transaction is added by the database.
 <p>
 Only this <a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html" title="class in org.firebirdsql.gds.ng"><code>AbstractFbDatabase</code></a> instance should call this method.
 </p></div>
</li>
</ul>
<a name="getConnectionDialect--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConnectionDialect</h4>
<pre>public final&nbsp;short&nbsp;getConnectionDialect()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getConnectionDialect--">getConnectionDialect</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The client connection dialect</dd>
</dl>
</li>
</ul>
<a name="getDatabaseDialect--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDatabaseDialect</h4>
<pre>public final&nbsp;short&nbsp;getDatabaseDialect()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getDatabaseDialect--">getDatabaseDialect</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The database dialect</dd>
</dl>
</li>
</ul>
<a name="setDatabaseDialect-short-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setDatabaseDialect</h4>
<pre>protected final&nbsp;void&nbsp;setDatabaseDialect(short&nbsp;dialect)</pre>
<div class="block">Sets the dialect of the database.
 <p>
 This method should only be called by this instance.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>dialect</code> - Dialect of the database/connection</dd>
</dl>
</li>
</ul>
<a name="addDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addDatabaseListener</h4>
<pre>public final&nbsp;void&nbsp;addDatabaseListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners">DatabaseListener</a>&nbsp;listener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#addDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">FbDatabase</a></code></span></div>
<div class="block">Adds a <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>DatabaseListener</code></a> instance to this database.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#addDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">addDatabaseListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - Database listener</dd>
</dl>
</li>
</ul>
<a name="addWeakDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addWeakDatabaseListener</h4>
<pre>public final&nbsp;void&nbsp;addWeakDatabaseListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners">DatabaseListener</a>&nbsp;listener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#addWeakDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">FbDatabase</a></code></span></div>
<div class="block">Adds a <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>DatabaseListener</code></a> instance to this database using a weak reference.
 <p>
 If the listener is already strongly referenced, this call will be ignored
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#addWeakDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">addWeakDatabaseListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - Database listener</dd>
</dl>
</li>
</ul>
<a name="removeDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeDatabaseListener</h4>
<pre>public final&nbsp;void&nbsp;removeDatabaseListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners">DatabaseListener</a>&nbsp;listener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#removeDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">FbDatabase</a></code></span></div>
<div class="block">Removes a <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>DatabaseListener</code></a> instance from this database.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#removeDatabaseListener-org.firebirdsql.gds.ng.listeners.DatabaseListener-">removeDatabaseListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - Database Listener</dd>
</dl>
</li>
</ul>
<a name="internalDetach--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>internalDetach</h4>
<pre>protected abstract&nbsp;void&nbsp;internalDetach()
                                throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Actual implementation of database detach.
 <p>
 Implementations of this method should only be called from <a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#close--"><code>close()</code></a>, and should <strong>not</strong>
 notify database listeners of the database <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html#detaching-org.firebirdsql.gds.ng.FbDatabase-"><code>DatabaseListener.detaching(FbDatabase)</code></a> and
 <a href="../../../../org/firebirdsql/gds/ng/listeners/DatabaseListener.html#detached-org.firebirdsql.gds.ng.FbDatabase-"><code>DatabaseListener.detached(FbDatabase)</code></a> events.
 </p></div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="close--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public final&nbsp;void&nbsp;close()
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Detaches and closes the connection.
 <p>
 Implementation note: Calls <a href="../../../../org/firebirdsql/gds/ng/AbstractFbAttachment.html#checkConnected--"><code>AbstractFbAttachment.checkConnected()</code></a> and notifies database listeners of the detaching event, then
 calls <a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#internalDetach--"><code>internalDetach()</code></a> and finally notifies database listeners of database detach and removes all
 listeners.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true#close--" title="class or interface in java.lang">close</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a></code></dd>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html#close--">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html" title="interface in org.firebirdsql.gds.ng">FbAttachment</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If not currently connected, or another problem occurred detaching.</dd>
</dl>
</li>
</ul>
<a name="getOdsMajor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getOdsMajor</h4>
<pre>public final&nbsp;int&nbsp;getOdsMajor()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getOdsMajor--">getOdsMajor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>ODS major version</dd>
</dl>
</li>
</ul>
<a name="setOdsMajor-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setOdsMajor</h4>
<pre>protected final&nbsp;void&nbsp;setOdsMajor(int&nbsp;odsMajor)</pre>
<div class="block">Sets the ODS (On Disk Structure) major version of the database associated
 with this connection.
 <p>
 This method should only be called by this instance.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>odsMajor</code> - ODS major version</dd>
</dl>
</li>
</ul>
<a name="getOdsMinor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getOdsMinor</h4>
<pre>public final&nbsp;int&nbsp;getOdsMinor()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getOdsMinor--">getOdsMinor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>ODS minor version</dd>
</dl>
</li>
</ul>
<a name="setOdsMinor-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setOdsMinor</h4>
<pre>protected final&nbsp;void&nbsp;setOdsMinor(int&nbsp;odsMinor)</pre>
<div class="block">Sets the ODS (On Disk Structure) minor version of the database associated
 with this connection.
 <p>
 This method should only be called by this instance.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>odsMinor</code> - The ODS minor version</dd>
</dl>
</li>
</ul>
<a name="getStatementInfoRequestItems--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getStatementInfoRequestItems</h4>
<pre>public final&nbsp;byte[]&nbsp;getStatementInfoRequestItems()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The (full) statement info request items.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getParameterDescriptionInfoRequestItems--"><code>getParameterDescriptionInfoRequestItems()</code></a></dd>
</dl>
</li>
</ul>
<a name="getParameterDescriptionInfoRequestItems--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParameterDescriptionInfoRequestItems</h4>
<pre>public final&nbsp;byte[]&nbsp;getParameterDescriptionInfoRequestItems()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The <code>isc_info_sql_describe_vars</code> info request items.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/AbstractFbDatabase.html#getStatementInfoRequestItems--"><code>getStatementInfoRequestItems()</code></a></dd>
</dl>
</li>
</ul>
<a name="getDatabaseInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDatabaseInfo</h4>
<pre>public final&nbsp;&lt;R&gt;&nbsp;R&nbsp;getDatabaseInfo(byte[]&nbsp;requestItems,
                                   int&nbsp;bufferLength,
                                   <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;R&gt;&nbsp;infoProcessor)
                            throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getDatabaseInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">FbDatabase</a></code></span></div>
<div class="block">Request database info.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getDatabaseInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">getDatabaseInfo</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>requestItems</code> - Array of info items to request</dd>
<dd><code>bufferLength</code> - Response buffer length to use</dd>
<dd><code>infoProcessor</code> - Implementation of <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng"><code>InfoProcessor</code></a> to transform
         the info response</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Transformed info response of type T</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - For errors retrieving or transforming the response.</dd>
</dl>
</li>
</ul>
<a name="getDescribeDatabaseInfoBlock--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDescribeDatabaseInfoBlock</h4>
<pre>protected&nbsp;byte[]&nbsp;getDescribeDatabaseInfoBlock()</pre>
</li>
</ul>
<a name="getDatabaseInformationProcessor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDatabaseInformationProcessor</h4>
<pre>protected&nbsp;<a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;<a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>&gt;&nbsp;getDatabaseInformationProcessor()</pre>
</li>
</ul>
<a name="transactionStateChanged-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.ng.TransactionState-org.firebirdsql.gds.ng.TransactionState-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>transactionStateChanged</h4>
<pre>public final&nbsp;void&nbsp;transactionStateChanged(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;transaction,
                                          <a href="../../../../org/firebirdsql/gds/ng/TransactionState.html" title="enum in org.firebirdsql.gds.ng">TransactionState</a>&nbsp;newState,
                                          <a href="../../../../org/firebirdsql/gds/ng/TransactionState.html" title="enum in org.firebirdsql.gds.ng">TransactionState</a>&nbsp;previousState)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html#transactionStateChanged-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.ng.TransactionState-org.firebirdsql.gds.ng.TransactionState-">TransactionListener</a></code></span></div>
<div class="block">Signals that the transaction state changed.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html#transactionStateChanged-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.ng.TransactionState-org.firebirdsql.gds.ng.TransactionState-">transactionStateChanged</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">TransactionListener</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>transaction</code> - <a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng"><code>FbTransaction</code></a> that changed state</dd>
</dl>
</li>
</ul>
<a name="createBlobParameterBuffer--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createBlobParameterBuffer</h4>
<pre>public&nbsp;<a href="../../../../org/firebirdsql/gds/BlobParameterBuffer.html" title="interface in org.firebirdsql.gds">BlobParameterBuffer</a>&nbsp;createBlobParameterBuffer()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobParameterBuffer--">FbDatabase</a></code></span></div>
<div class="block">Creates a blob parameter buffer that is usable with <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobForInput-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.BlobParameterBuffer-long-"><code>FbDatabase.createBlobForInput(FbTransaction,
 org.firebirdsql.gds.BlobParameterBuffer, long)</code></a>
 and <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobForOutput-org.firebirdsql.gds.ng.FbTransaction-org.firebirdsql.gds.BlobParameterBuffer-"><code>FbDatabase.createBlobForOutput(FbTransaction, org.firebirdsql.gds.BlobParameterBuffer)</code></a> of this instance.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createBlobParameterBuffer--">createBlobParameterBuffer</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A blob parameter buffer.</dd>
</dl>
</li>
</ul>
<a name="createTransactionParameterBuffer--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createTransactionParameterBuffer</h4>
<pre>public&nbsp;<a href="../../../../org/firebirdsql/gds/impl/TransactionParameterBufferImpl.html" title="class in org.firebirdsql.gds.impl">TransactionParameterBufferImpl</a>&nbsp;createTransactionParameterBuffer()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createTransactionParameterBuffer--">FbDatabase</a></code></span></div>
<div class="block">Creates a transaction parameter buffer that is usable with <a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#startTransaction-org.firebirdsql.gds.TransactionParameterBuffer-"><code>FbDatabase.startTransaction(org.firebirdsql.gds.TransactionParameterBuffer)</code></a>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#createTransactionParameterBuffer--">createTransactionParameterBuffer</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A transaction parameter buffer</dd>
</dl>
</li>
</ul>
<a name="getConnectionProperties--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConnectionProperties</h4>
<pre>public&nbsp;<a href="../../../../org/firebirdsql/gds/ng/IConnectionProperties.html" title="interface in org.firebirdsql.gds.ng">IConnectionProperties</a>&nbsp;getConnectionProperties()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#getConnectionProperties--">getConnectionProperties</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>An immutable copy of the connection properties of this database</dd>
</dl>
</li>
</ul>
<a name="emptyRowDescriptor--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>emptyRowDescriptor</h4>
<pre>public final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;emptyRowDescriptor()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html#emptyRowDescriptor--">emptyRowDescriptor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A potentially cached empty row descriptor for this database.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbBlob.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbService.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/AbstractFbDatabase.html" target="_top">Frames</a></li>
<li><a href="AbstractFbDatabase.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields.inherited.from.class.org.firebirdsql.gds.ng.AbstractFbAttachment">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
